#include <stdlib.h>
#include <stdio.h>
#include <stdbool.h>
#include <assert.h>
#include "pile_ptr.h"


//Creer une nouvelle pile vide
pile pile_creer() {
   return NULL;
}

//Tester si la pile est vide
bool pile_est_vide(pile stack) {
	return (NULL == stack);
}

//Inserer un élement en début de pile
void pile_empiler(pile* stack,info val) {
   element* elmt = malloc(sizeof(element));
   elmt->data = val;
   elmt->next = *stack;
   *stack = elmt;
}

//Consulter l'élément au sommet de la pile
info pile_sommet(pile stack) {
   assert(!pile_est_vide(stack));
   return stack->data;
}

//Supprimer un élément de la pile
info pile_depiler(pile* stack) {
   info data = pile_sommet(*stack);
   element* elmt = *stack;
   *stack = (*stack)->next; 
   free(elmt);    
   return data; 
}

//Désallouer complètement la pile
void pile_detruire(pile* stack) {
   while (!pile_est_vide(*stack)) {      
      pile_depiler(stack);
   }   
}

//Compter le nombre d'éléments de la pile:
int pile_count(pile stack) {
   int cnt = 0;
   while (NULL != stack) {      
      stack = stack->next;
      cnt++;
   }
   return cnt;
}




